#include <bits/stdc++.h>
using namespace std;

int main() {


	int n;
	cin>>n>>m;
  for (int i=1; i<=m; i++){
        int v1,v2;
    cin>>v1>>v2;
    a[v1][v2]++;
    d[v1]++;
  }
    cout<<"NO"<<"\n";
}
